-- frmMainWidget.lua
-- Originally TheOneBagWindow.lua written by Rod, extended by Habna


--v IMPORT SECTION v--
import "HabnaPlugins.HugeBag.settingsWidget"; -- LUA settings file
import "HabnaPlugins.HugeBag.functionsWidget"; -- LUA functions file
import "HabnaPlugins.HugeBag.color"; -- LUA Color file
import "HabnaPlugins.HugeBag.GlobalVariableWidget"; -- LUA GlobalVariable file
import "HabnaPlugins.HugeBag.sortingList"; -- LUA SortingList file
import "HabnaPlugins.HugeBag.moveWidget"; -- LUA MoveWidget file
import "HabnaPlugins.HugeBag.contextMenuWidget"; -- LUA ContextMenu file
--^ IMPORT SECTION ^--
--v GLOBAL VARIABLE SECTION v--
frmMain = class( Turbine.UI.Window );
--frmMain = class( Turbine.UI.Lotro.GoldWindow ); --Gold Window
--^ GLOBAL VARIABLE SECTION ^--

function frmMain:Constructor()
	--v SETTINGS SECTION v--
	--Turbine.UI.Window.Constructor( self );
	Turbine.UI.Window.Constructor( self );

	self.cursor = nil;
	--Turbine.UI.Lotro.GoldWindow.Constructor( self ); --Gold Window
	
	-- **v Get player gameplay v**
	if pcall( Turbine.Gameplay.LocalPlayer.GetInstance ) then
		self.backpack = Turbine.Gameplay.LocalPlayer.GetInstance():GetBackpack();
	else
		self.backpack = Turbine.Gameplay.LocalPlayer():GetBackpack();
	end
	-- **^

	backpackSize = self.backpack:GetSize();
	LoadSettings();
		
	--**v Set some settings of HugeBag window v**
	self:SetVisible( true );
	if ( StartVisible ) then
		windowOpen = true;
		self:SetLeft( screenWidth - ( winRate * 15 ) + 2 );
	else
		windowOpen = false;
		self:SetLeft( screenWidth - 28 );
	end
	self:SetOpacity( 1 );
	self:SetAllowDrop( true );
	self:SetWantsKeyEvents( true );
	--self:SetWantsUpdates( true );
	self:SetZOrder( 5 );
	--**^
	-- **v Set Top and size of window v** --
	if backpackSize == 45 then
		self:SetTop( WinLocY );
		self:SetSize( WinWidth, WinHeight - 69 );
	else
		self:SetTop( WinLocY );
		self:SetSize( WinWidth, WinHeight );
	end
	-- **^

	sortCtr = Turbine.UI.Control();
	slideCtr = Turbine.UI.Control();
	mouseCtr = Turbine.UI.Control();
	
	-- **v Set control bar v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( self );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 30, 20 );
	--topLeftCorner:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );
	
	leftBar = Turbine.UI.Control();
	leftBar:SetParent( self );
	leftBar:SetPosition( 0, 20 );
	leftBar:SetSize( 30, self:GetHeight() - 20 );
	--leftBar:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );

	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( self );
	botLeftCorner:SetPosition( 0, self:GetHeight() - 20 );
	botLeftCorner:SetSize( 30, 20 );
	--botLeftCorner:SetBackColor( Turbine.UI.Color( .6, 0, 0, 0 ) );
	
	-- **^
	-- **v Set Image on control bar v** --
	tt = Turbine.UI.Control();
	tt:SetParent( topLeftCorner );
	tt:SetPosition( 0, 0);
	tt:SetSize( 30, 20);
	tt:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_top.tga" );
	tt:SetMouseVisible( false );
	
	tm = Turbine.UI.Control();
	tm:SetParent( leftBar );
	tm:SetPosition( 0, 0);
	tm:SetSize( 30, leftBar:GetHeight() - 20 );
	tm:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_mid.tga" );
	tm:SetMouseVisible( false );
	
	tb = Turbine.UI.Control();
	tb:SetParent( botLeftCorner );
	tb:SetPosition( 0, 0 );
	tb:SetSize( 30, 20 );
	tb:SetBackground( "HabnaPlugins/HugeBag/Resources/tab_bottom.tga" );
	tb:SetMouseVisible( false );
	
	tlabel = Turbine.UI.Control();
	tlabel:SetParent( leftBar );
	tlabel:SetZOrder( 10 );
	tlabel:SetPosition( 9, ( self:GetHeight() / 2 ) - 62 );
	tlabel:SetSize( 14, 88 );
	tlabel:SetBackground( "HabnaPlugins/HugeBag/Resources/label.tga" );
	tlabel:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	tlabel:SetMouseVisible( false );
	
	top = Turbine.UI.Control();
	top:SetParent( self );
	top:SetPosition( 30, 0 );
	top:SetSize( self:GetWidth() - 60, 30 );
	top:SetBackground( "HabnaPlugins/HugeBag/Resources/top.tga" );
	top:SetMouseVisible( false );
	
	bot = Turbine.UI.Control();
	bot:SetParent( self );
	bot:SetPosition( 30, self:GetHeight() - 30 );
	bot:SetSize( self:GetWidth() - 60, 30 );
	bot:SetBackground( "HabnaPlugins/HugeBag/Resources/bot.tga" );
	bot:SetMouseVisible( false );

	SortButton = Turbine.UI.Button();
	SortButton:SetParent( self );
	SortButton:SetPosition( 35,  220 );
	SortButton:SetSize( 75, 150 );
	SortButton:SetForeColor( gray );
	SortButton:SetText( "Sort bag" );
	SortButton:SetOutlineColor( black );
	SortButton:SetFontStyle( Turbine.UI.FontStyle.Outline );
	SortButton:SetVisible( true );
	
	right = Turbine.UI.Control();
	right:SetParent( self );
	right:SetPosition( self:GetWidth() - 30, 0 );
	right:SetSize( 30, self:GetHeight() );
	right:SetBackground( "HabnaPlugins/HugeBag/Resources/right.tga" );
	right:SetMouseVisible( false );
	
	rlabel = Turbine.UI.Control();
	rlabel:SetParent( self );
	rlabel:SetZOrder( 10 );
	rlabel:SetPosition( self:GetWidth() - 20, ( self:GetHeight() / 2 ) - 42 );
	rlabel:SetSize( 14, 88 );
	rlabel:SetBackground( "HabnaPlugins/HugeBag/Resources/label.tga" );
	rlabel:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	rlabel:SetMouseVisible( false );
	-- **^
	-- **v Title setting v**
	lblTitle = Turbine.UI.Label();
	lblTitle:SetParent( self );
	lblTitle:SetSize( self:GetWidth() - 60, 30 );
	lblTitle:SetPosition( 30, 0 );
	lblTitle:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleCenter );
	lblTitle:SetFont( Turbine.UI.Lotro.Font.TrajanPro19 );
	lblTitle:SetForeColor( rustedgold );
	lblTitle:SetOutlineColor( black );
	lblTitle:SetFontStyle( Turbine.UI.FontStyle.Outline );
	lblTitle:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	-- **^
	-- **v Set some settings of the itemlistbox v**
	itemListBox = Turbine.UI.ListBox();
	itemListBox:SetParent( self );
	itemListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	itemListBox:SetPosition( InitXPos, InitYPos );
	itemListBox:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	itemListBox:SetMaxItemsPerLine( 11 );
	--itemListBox:SetBlendMode( Turbine.UI.BlendMode.Overlay );
	-- **^
	
	-- **v Set size of the listbox v** --
	if backpackSize == 45 then
		itemListBox:SetSize( 389, 180 ); -- to show 45 slots
	else
		itemListBox:SetSize( 389, 249 ); -- to show 75 slots
	end
	-- **^
	self:SetBackPack(); --> ** Set the backpack **
	--local temp =  --itemListBox:GetBackColor();
	--write("BC: " .. temp );
	--^ SETTINGS SECTION ^--
	
	--v EVENT HANDLERS SECTION v--

	-- **v Button click event v**
	SortButton.Click = function(sender, args)
		SortHugeBag()
	end

	SortButton.MouseHover = function(sender, args)
		SortButton:SetForeColor( green );
	end

	SortButton.MouseLeave = function(sender, args)
		SortButton:SetForeColor( gray );
	end
	-- **^

	--**v control bar event handlers v**
	
	leftBar.MouseEnter = function( sender, args )
		tt:SetBackground("HabnaPlugins/HugeBag/Resources/tab_top_over.tga");
		tb:SetBackground("HabnaPlugins/HugeBag/Resources/tab_bottom_over.tga");
		tm:SetBackground("HabnaPlugins/HugeBag/Resources/tab_mid_over.tga");
		tlabel:SetBackground("HabnaPlugins/HugeBag/Resources/label_over.tga");
	end

	leftBar.MouseLeave = function( sender, args )
		tt:SetBackground("HabnaPlugins/HugeBag/Resources/tab_top.tga");
		tb:SetBackground("HabnaPlugins/HugeBag/Resources/tab_bottom.tga");
		tm:SetBackground("HabnaPlugins/HugeBag/Resources/tab_mid.tga");
		tlabel:SetBackground("HabnaPlugins/HugeBag/Resources/label.tga");
	end
	
	leftBar.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			slideCtr:SetWantsUpdates(true);
		end
	end

	topLeftCorner.MouseHover = function( sender, args )
		MouseHover()
	end

	topLeftCorner.MouseLeave = function ( args )
		MouseLeave()
	end

	topLeftCorner.MouseDown = function( sender, args )
		MouseDown( sender, args )
	end

	topLeftCorner.MouseUp = function( sender, args )
		MouseUp( sender, args )
	end

	topLeftCorner.MouseMove = function( sender, args )
		MouseMove( sender, args )
	end

	botLeftCorner.MouseHover = function( sender, args )
		MouseHover()
	end

	botLeftCorner.MouseLeave = function ( args )
		MouseLeave()
	end

	botLeftCorner.MouseDown = function( sender, args )
		MouseDown( sender, args )
	end

	botLeftCorner.MouseUp = function( sender, args )
		MouseUp( sender, args )
	end

	botLeftCorner.MouseMove = function( sender, args )
		MouseMove( sender, args )
	end

	topLeftCorner.MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Left ) then
			slideCtr:SetWantsUpdates(true);
		elseif ( args.Button == Turbine.UI.MouseButton.Right ) then
			menu:ShowMenu()
		end
	end
	
	-- **^
	--**v HugeBag event handlers v**
	slideCtr.Update = function( sender, args )
		tscreenWidth, tscreenHeight = Turbine.UI.Display.GetSize()
		
		if ( tscreenWidth ~= screenWidth ) then
			self:SetTop( WinLocY );
			
			if ( windowOpen ) then
				self:SetLeft( tscreenWidth - ( winRate * 15 ) + 2 );
			else
				self:SetLeft( tscreenWidth - 28 );
			end
		screenWidth = tscreenWidth;
		end
		
		if ( windowOpen ) then
			if ( self:GetLeft() == ( screenWidth - 28 ) ) then
				self:SetLeft( self:GetLeft() )
				slideCtr:SetWantsUpdates( false );
				windowOpen = false;
			else
				self:SetLeft( self:GetLeft() + winRate )
			end
		else
			if ( self:GetLeft() == ( screenWidth - ( winRate * 15 ) + 2 ) ) then
				self:SetLeft( self:GetLeft() )
				slideCtr:SetWantsUpdates( false );
				windowOpen = true;
			else
				self:SetLeft( self:GetLeft() - winRate )
			end
		end
	end

	sortCtr.Update = function( sender, args )
		local Time = Turbine.Engine.GetGameTime()
		local elapsed = Time - Start
		
		if Slot > backpackSize then
			sortCtr:SetWantsUpdates(false)
			write( "HugeBag: Sorting finished" )
		else
			--Get the name of the target item
			target = VirtPack[Slot].Name
		
			--Get item in current slot
			item = frmMain.backpack:GetItem(Slot)
			
			--Get the name of the item in the current slot. If empty return that name as "zEmpty"
			if item ~= nil then Name = item:GetName() else Name = "zEmpty" end

			--write("<rgb=#888888>Slot "..Slot.." should contain "..target.." but contains ".. Name)
			
			--If the Name of the current item is equal to the target name, move on.
			if Name == target then Slot = Slot + 1 return end	
			
			if elapsed > 0.2 then
				--Search for the item in the rest of the pack.
				for i = Slot , backpackSize do
					item = frmMain.backpack:GetItem(i)
					if item ~= nil then item = item:GetName() else item = "zEmpty" end
					if item == target then 
						swop( i, Slot)
						Start= Turbine.Engine.GetGameTime()
						return
					end
				end
				write( "Should never get here! Error in Update function." )
				--write("<rgb=#888888>Should never get here! Error in Update function. Did your inventory change during the sort? Restarting!")
				--sortCtr:SetWantsUpdates(false)
				--SortHugeBag()
			end
		end
	end

	mouseCtr.Update = function( sender, args )
		local mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition()
		write(mouseXPos..","..mouseYPos);
		if mouseYPos == self:GetTop() + 2 then
			write("change icon to a cursor");
			createCursor( upCursor, mouseXPos, mouseYPos )
		end
	end

	self.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			if ( HideWEsc ) then
				if ( windowOpen ) then
					slideCtr:SetWantsUpdates(true);
				end
			else
				self:SetVisible( true ); -- **v DO NOT Hide HugeBag if ESC key is press v**
			end
		end
		
		if ( args.Action == Turbine.UI.Lotro.Action.ToggleBags or
		     args.Action == Turbine.UI.Lotro.Action.ToggleBag1 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag2 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag3 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag4 or
			 args.Action == Turbine.UI.Lotro.Action.ToggleBag5 )
		then			
			slideCtr:SetWantsUpdates(true);
		end
	end

	self.DragDrop = function( sender, args )
		local shortcut = args.DragDropInfo:GetShortcut();
		local destinationItemControl = itemListBox:GetItemAt( args.X - InitXPos, args.Y - InitYPos );
		
		if ( destinationItemControl ~= nil ) then -- ** if nil, then it's out of range, so don't do anything **
			local destinationIndex = itemListBox:IndexOfItem( destinationItemControl );
			self.backpack:PerformShortcutDrop(shortcut, destinationIndex, Turbine.UI.Control.IsShiftKeyDown() );
		end
	end
	--**^ HugeBag event handlers ^**
	-- **v backpack event handlers v**
	self.backpack.ItemAdded = function( sender, args )
		items[args.Index]:SetItem( self.backpack:GetItem( args.Index ) );
		freeslots = freeslots -1;
		self:PrintTitle()
	end
	
	self.backpack.ItemRemoved = function( sender, args )
		items[args.Index]:SetItem( self.backpack:GetItem( args.Index ) );
		freeslots = freeslots +1;
		self:PrintTitle()
	end
	
	self.backpack.ItemMoved = function( sender, args )
		items[args.OldIndex]:SetItem( self.backpack:GetItem( args.OldIndex ) );
		items[args.NewIndex]:SetItem( self.backpack:GetItem( args.NewIndex ) );
	end
	--**^ backpack event handlers ^**
	--^ EVENT HANDLERS SECTION ^--
end
-- **^

--v FUNCTIONS/METHODS SECTION v--
-- **v Refresh the backpack list v**
function frmMain:SetBackPack()
	items = nil;
	itemListBox:ClearItems();

	items = {}; --> ** Initialize the container that holds the elements referencing the player's inventory **
	--backpackSize = self.backpack:GetSize();
	
	local temp;

	for i = 1, backpackSize, 1 do
		if ( items[i] ) then
			items[i]:SetParent( nil );
		end
		
		-- Get item and set background color
		--self.items[i] = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		temp = Turbine.UI.Lotro.ItemControl( self.backpack:GetItem( i ) );
		temp:SetBackground( "HabnaPlugins/HugeBag/Resources/slotBackground.tga" );
		temp:SetBlendMode( Turbine.UI.BlendMode.Overlay );
		items[i] = temp;
		items[i].id = i; -- For sorting purpose

		itemListBox:AddItem( items[i] );
	end
	
	self:CountFreeSlots()
end
-- **^
-- **v Count the free slots v**
function frmMain:CountFreeSlots()
	freeslots = 0;

	for i = 1, backpackSize, 1 do
		if ( self.backpack:GetItem( i ) == nil ) then
			freeslots = freeslots + 1;
		end
	end

	self:PrintTitle()
end
-- **^
-- **v Print the title with the free slots and the max v**
function frmMain:PrintTitle()
	local usedslots = backpackSize - freeslots;
	lblTitle:SetText( "Free slots: " .. freeslots .. "  Used slots: " .. usedslots .. "  Max slots: " .. backpackSize );
end
-- **^
--^ FUNCTIONS/METHODS SECTION ^--